<template>
    <q-card class="rounded-corners bordered">
        <q-card-section>
            <q-item>
                <q-item-section avatar>
                    <q-avatar size="5em"> <img :src="user.avatar"> </q-avatar>
                </q-item-section>
                <q-item-section>{{user.firstName}} {{user.lastName}}</q-item-section>
                <q-item-label caption>@{{user.username}}</q-item-label>
            </q-item>
        </q-card-section>
        <q-separator />
        <q-expansion-item expand-separator icon="perm_identity" label="Personal Infos" :caption="user.username"
         v-model="expandedInfos" >
            <q-card-section>
                <q-card flat>
                    <q-form @submit="updateUser()"  >
                        <q-card-section>
                            <div class="q-gutter-none">
                                <q-input type="email" v-model="user.email" label="Email"  />
                                <q-input type="text" v-model="user.firstName" label="First Name" />
                                <q-input type="text" v-model="user.lastName" label="Last Name" />
                                <q-input type="text" v-model="user.organization" label="Organization"  />
                                <q-input type="text" v-model="user.status" label="Status" />
                                <q-input type="number" v-model="user.age" label="Age"  />
                                <q-select v-model="user.gender" :options="genders" label="Gender" />
                            </div>
                        </q-card-section>
                        <q-card-actions>
                            <q-btn label="Save" color="primary" icon="save" :loading="savingModifs" type="submit"></q-btn>
                        </q-card-actions>
                    </q-form>
                </q-card>
            </q-card-section>
        </q-expansion-item>
        
        <q-expansion-item expand-separator icon="build" label="Actions" v-model="expandedActions">
            <q-card-actions>
                <q-form @submit="updateRoles()" >
                    <q-select dense v-model="user.roles" :options="roles" multiple filled/>
                    <q-btn dense  type="submit" label="Save Role" color="primary" icon="save" :loading="savingRoles"></q-btn>
                    <q-btn dense @click="deleteUser()" label="Delete User" color="negative" icon="delete"></q-btn>
                </q-form>
                
            </q-card-actions>
        </q-expansion-item>
        
    </q-card>
</template>

<script>
import api from '../boot/backend-api';
import Store from '../store/index';

export default {
    name: 'user',
    props: ['userData'],
    data() {
        return {
            tab: 'mails',
            user: this.userData,
            // user: {  username: 'jluce',firstName: 'Luce',lastName: 'Joeltz', age: 23, gender: 'female', email: 'fluce@gmail.com', 
            //     organization: 'Inria', status: 'Intern', avatar: 'https://localhost:8098/downloadFile/gael-avatar.jpg',
            //     roles: [
            //         {
            //             "id": 1,
            //             "roleName": "STANDARD_USER",
            //             "description": "Standard User - Has no admin rights"
            //         }
            //     ]
            // },
            genders: ['female', 'male'],
            roles: ['ADMIN_USER', 'STANDARD_USER'],
            expandedInfos: false,
            expandedActions: false,
            savingModifs: false,
            savingRoles: false,
            alerts: { 'deleted': {color: 'positive', message: this.username + ' is deleted'},
                'saved': {color: 'positive', message: 'Modifications saved'},
                'saveerror': {color : 'negative', message: 'Not saved. May be a server issue.', icon: 'report_problem'},
                'delete-error': {color: 'negative', message: 'Not deleted. May be a server issue.', icon: 'report_problem'}}
        }
    },
    mounted(){
        // obtain list of role names from the user infos
        let result = this.user.roles.map(role => role.roleName);
        this.user.roles = result;
    },
    methods: {
        updateUser() {
            //update this user based on user.username
            this.savingModifs = true;
            let promise = api.updateUserInfos(this.user, this.user.username);
            promise.then(response => {
                this.showNotif('top-right', 'saved');
                this.savingModifs = false;
                this.expandedInfos = false;
            }).catch(error => {
                console.log(error);
                this.showNotif('bottom-right', 'saveerror');
                this.savingModifs = false;
            });
        },
        updateRoles() {
            this.savingRoles = true;
            let promise = api.updateUserRoles(this.user.username, this.user.roles);
            promise.then( response => {
                this.showNotif('top-right', 'saved');
                this.savingRoles = false;
                this.expandedActions = false;
            }).catch(error => {
                console.log(error);
                this.showNotif('bottom-right', 'saveerror');
                this.savingActions = false;
            });
        },
        deleteUser() {
            api.deleteUser(this.user.username)
            .then(response => {
                this.showNotif('top-right', 'deleted');
                this.adminGetUsers();
            }).catch(error => {
                console.log(error);
                this.showNotif('top-right', 'delete-error')
            });
        },
        adminGetUsers: function(){
            this.$root.$emit('componentAdmin');
        },
        showNotif (position, alert) {
            const { color, textColor, multiLine, icon, message, avatar, actions } = this.alerts[alert];
            const buttonColor = color ? 'white' : void 0;
            this.$q.notify({
                color,
                textColor,
                icon: icon,
                message,
                position,
                avatar,
                multiLine,
                actions: actions,
                timeout: 2000
            })
        }
    }
}
</script>

<style scoped>

</style>
